
// Prepare for the plant work
// fixedplant(Nodeid,Plantid,Birthtime,Parent)
// timeplant(Nodeid,Time,Size)

fixedplant:get `:tables/fixedplant;
timeplant:get `:tables/timeplant;
// direct children of node y in tree x
c:{[x;y] exec Nodeid from x where Parent in ((),y)}
// parent of node y in tree x
p:{[x;y] first exec Parent from x where Nodeid=y}
// descendants of node y in tree x
d:{[x;y] c[x;]\[(),y]}
// descendants of node with degree of separation
// includes self at degree 0, children have degree > 0
// tree x, node y
dd:{flip `descendant`degree!flip raze ns,\:'til count ns:d[x;y]}
// path to root (i.e. ancestors)
a:{p[x;]\[y]}
// ancestors with degree of separation
// includes self at degree 0, ancestors have degree < 0
// tree x, node y
ad:{flip `ancestor`degree!flip -2_ns,'neg til count ns:a[x;y]}
// full table of relation `r` in table `t`
// relation table and add column stating node used
// exclude self on output
ft:{[t;r] rt:raze {[x;y] update of:y from x}'[r[t;] each ns;ns:t`Nodeid]; select from rt where degree<>0 }
// full table of ancestors
ancestors:ft[;ad]
// full table of descendants
descendants:ft[;dd]
anctable: ancestors fixedplant
desctable: descendants fixedplant
save `:anctable
save `:desctable
